# Functions for printing messages
#
# Copyright (C) 2013  Patrick "P. J." McDermott
#
# This file is part of the ProteanOS Development Kit.
#
# The ProteanOS Development Kit is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# The ProteanOS Development Kit is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the ProteanOS Development Kit.  If not, see
# <http://www.gnu.org/licenses/>.

[ "x${_OUTPUT_SM+set}" = 'xset' ] && return 0
_OUTPUT_SM=1

error()
{
	local status=${1}
	local fmt="${2}"
	shift 2

	printf '%s: Error: ' "${0##*/}" >&2
	printf "${fmt}\n" "${@}" >&2

	exit ${status}
}

warn()
{
	local fmt="${1}"
	shift 1

	printf '%s: Warning: ' "${0##*/}" >&2
	printf "${fmt}\n" "${@}" >&2

	return 0
}

info()
{
	local fmt="${1}"
	shift 1

	printf '%s: ' "${0##*/}" >&2
	printf "${fmt}\n" "${@}" >&2

	return 0
}
